/*
   ----------------------------------------------------------------
   Description:

      This class creates a .csv-file in the very right field-order, which
      can be imported by the Palm Desktop Software.
   
   
   Programmers:
   
      Bernd Hohenester, newsletter@hobe.de
   
   
   History:
   
      13 Aug 2006  initial release
                   
   
   Usage:
   
      set procedure to palm.cc additive
      p = new palm()
      p.Name = "Hohenester"
      p.FirstName = "Bernd"
      p.Email = "newsletter@hobe.de"
      p.Url = "http://www.hobe.de"
      p.OpenFile("palm.csv")
      p.Write()
      close procedure palm.cc
      
      
   Functions:

   OpenFile(cFile) - creates the CSV-file
                     If cFile is empty the file-dialog comes up and asks for the .csv
                     
   write()         - writes a single line in cFile
                       
*/


class Palm of object custom
  
  this.Nachname = ""
  this.Vorname = ""
  this.Titel = ""
  this.Firma = ""
  this.Tel_Buero = ""
  this.Tel_Privat = ""
  this.Tel_Fax = ""
  this.EMail = ""
  this.Tel_Handy = ""
  this.Adressen1 = ""
  this.Ort1 = ""
  this.Bundesland1 = ""
  this.PLZ1 = ""
  this.Land1 = ""
  this.Bendef1 = ""
  this.Bendef2 = ""
  this.Bendef3 = ""
  this.Bendef4 = ""
  this.Notiz = ""
  this.Privat = false
  this.Kategorie = ""
  this.Pager = ""
  this.Haupt = ""
  this.Adressen2 = ""
  this.Ort2 = ""
  this.Bundesland2 = ""
  this.PLZ2 = ""
  this.Land2 = ""
  this.Adressen3 = ""
  this.Ort3 = ""
  this.Bundesland3 = ""
  this.PLZ3 = ""
  this.Land3 = ""
  this.Webseite = ""
  this.Geburtstag = ""
  this.Chat1 = ""
  this.Chat2 = ""
  this.Bendef5 = ""
  this.Bendef6 = ""
  this.Bendef7 = ""
  this.Bendef8 = ""
  this.Bendef9 = ""
  
  this.cFile = ""



  function OpenFile(cFile)

    if empty(cFile)
      try
        cFile = putfile("Save data to", "", "csv", true, "csv")
      catch (exception e)
        cFile = putfile("Save data to", "", "csv", true)
      endtry
      
      if empty(cFile)
        return false
      endif
    endif
    
    cFile = class::ValidFileName(cFile)
    
    local f, x
    f = new file()
    x = f.create(cFile, "A")
    if x
      this.cFile = cFile
      f.close()
    endif
    release object f
    f = null
    
  return x
  



  function Write()
    
#define alltrim(x) ltrim(rtrim(x))
#define cT "," 

    local temp
    
    temp = alltrim(this.Nachname) + cT
    temp += alltrim(this.Vorname) + cT
    temp += alltrim(this.Titel) + cT
    temp += alltrim(this.Firma) + cT
    temp += class::canonical(this.Tel_Buero) + cT
    temp += class::canonical(this.Tel_Privat) + cT
    temp += class::canonical(this.Tel_Fax) + cT
    temp += alltrim(this.EMail) + cT
    temp += class::canonical(this.Tel_Handy) + cT
    temp += alltrim(this.Adressen1) + cT
    temp += alltrim(this.Ort1) + cT
    temp += alltrim(this.Bundesland1) + cT
    temp += alltrim(this.PLZ1) + cT
    temp += alltrim(this.Land1) + cT
    temp += alltrim(this.Bendef1) + cT
    temp += alltrim(this.Bendef2) + cT
    temp += alltrim(this.Bendef3) + cT
    temp += alltrim(this.Bendef4) + cT
    temp += alltrim(this.Notiz) + cT
    temp += iif(this.Privat, "1", "") + cT  // Privat, wird mit 1 gekennzeichnet
    temp += alltrim(this.Kategorie) + cT
    temp += class::canonical(this.Pager) + cT
    temp += alltrim(this.Haupt) + cT
    temp += alltrim(this.Adressen2) + cT
    temp += alltrim(this.Ort2) + cT
    temp += alltrim(this.Bundesland2) + cT
    temp += alltrim(this.PLZ2) + cT
    temp += alltrim(this.Land2) + cT
    temp += alltrim(this.Adressen3) + cT
    temp += alltrim(this.Ort3) + cT
    temp += alltrim(this.Bundesland3) + cT
    temp += alltrim(this.PLZ3) + cT
    temp += alltrim(this.Land3) + cT
    temp += alltrim(this.Webseite) + cT
    temp += alltrim(this.Geburtstag) + cT
    temp += alltrim(this.Chat1) + cT
    temp += alltrim(this.Chat2) + cT
    temp += alltrim(this.Bendef5) + cT
    temp += alltrim(this.Bendef6) + cT
    temp += alltrim(this.Bendef7) + cT
    temp += alltrim(this.Bendef8) + cT
    temp += alltrim(this.Bendef9)


    local f
    f = new file()
    f.open(this.cFile, "A")
    f.puts(temp)
    f.flush()
    f.close()
    release object f
    f = null
    
  return
  
  
  
  function ValidFileName(cFileName)
    
    local cTemp, cRueck, i, ch
    
    cTemp = cFileName.righttrim().lefttrim()
    cRueck = ""
    
    for i = 1 to cTemp.length
      ch = substr(cTemp, i, 1)
      
      do case
        case ch $ '/*?"<>|'
          
        otherwise
          cRueck += ch
      endcase
    endfor
  return (cRueck)
  
  
  
  function canonical(cNummer)
    
    local cRueck, cPattern, re
    
    cRueck = cNummer.lefttrim().righttrim()
    
    if not empty(cRueck)
    cPattern = "(\+\d{2,4}|0)\s?(\d{2,4})\s?(\d{2,7})(-| )?(\d{4})?"
    re = new oleAutoClient("VBScript.RegExp")
    re.pattern = cPattern
    
    cRueck = re.replace( cNummer , "$1 ($2) $3$4$5")
    
    if substr(cRueck, 1, 2) == "0 "
      cRueck = "+49 " + substr(cRueck, 3)
    endif
    
    re = null
    endif
  return (cRueck.lefttrim().righttrim())



endclass
